package cn.net.cpzslibs.prot;

import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.lang.reflect.Type;
import java.net.Socket;
import java.util.List;

import cn.net.cpzslibs.prot.bean.req.Prot10020ReqBean16;
import cn.net.cpzslibs.prot.bean.res.Prot10020ResBean16;
import cn.net.cpzslibs.prot.utils.StrUtils;


public class Prot10020ProductDesc16 extends ProtBase {
	/**
	 * 是否成功
	 */
	private short iResult;
	
	private final short iTaskCode10020 = 10020;
	private Gson gson;
	private Prot10020ResBean16 productInfoResult;
	
	public Prot10020ProductDesc16() {
//		this.sInspectorId = sInspectorId;
		gson = new Gson();
	}
	
	public Prot10020ResBean16 getProductInfoResult(){
		return this.productInfoResult;
	}
	
	public void dealProductInfo(SocketCreate create, Prot10020ReqBean16 reqBean) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(), reqBean);
	}
	
	private void recProt(Socket socket, DataOutputStream dos,
			DataInputStream dis, Prot10020ReqBean16 reqBean)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				//发送登录信息
				debugLog(iTaskCode10020, "开始请求产品列表");
				sendProt(dos, reqBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recLoginDis(dis);
			}
		}
	}
	
	/**
	 * 读取JSon数据
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode10020, "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode10020, jsonData);
//		[{"companyName":"云南云天化股份有限公司","companyTel":"0870-8662731","companyUrl":"https://www.baidu.com/","consumeCode":"9762","description":"云天化","name":"复合肥","origin":"中国云南省","producer":"云南云天化股份有限公司","productId":"100002","productUrl":"","query_des":"磷肥"}]
//		JSONObject object1 = new JSONObject(content);
		if (!StrUtils.isEmpty(jsonData)) {
			/*productInfoResult = gson.fromJson(jsonData, Prot10020ResBean16.class);
			if (productInfoResult.getResult() == 0) {
				Prot10020ResBean16[] resList = gson.fromJson(jsonData, Prot10020ResBean16[].class);
				if (resList != null && resList.length > 0) {
					productInfoResult = resList[0];
					productInfoResult.setResult(0);
				}
			}*/
			
			if (jsonData.startsWith("{") || jsonData.endsWith("}")) {
				//表示当前数据为JSONObject
				productInfoResult = gson.fromJson(jsonData, Prot10020ResBean16.class);
			} else {
				Type type = new TypeToken<List<Prot10020ResBean16>>() {}.getType();  
				List<Prot10020ResBean16> resList = gson.fromJson(jsonData, type);
				if (resList != null && resList.size() > 0) {
					productInfoResult = resList.get(0);
					productInfoResult.setResult(0);
				}
			}
			
		}
		recCheckCode(dis);
	}
	
	
	/**
	 * 发送JSon数据到服务器
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos, Prot10020ReqBean16 reqBean) throws IOException {
		String bodyContent = gson.toJson(reqBean).toString();
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode10020, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
//		sendCheckCode(dos);
		sendCheckCoded(dos,bodyContent.getBytes("UTF-8"));
	}
	

}
